from fewspy.api import Api
from fewspy.constants.pi_settings import pi_settings_sa
from pathlib import Path

import pytest


@pytest.fixture(scope="session")
def fixture_api_sa_no_download_dir():
    api = Api(pi_settings=pi_settings_sa)
    assert api.pi_settings.base_url == pi_settings_sa.base_url
    assert api.pi_settings.ssl_verify == True  # noqa
    assert api.pi_settings.settings_name == "default stand-alone"
    assert api.pi_settings.filter_id == "INTERNAL-API"
    assert api.pi_settings.service == "FewsWebServices"
    assert api.pi_settings.module_instance_ids == "WerkFilter"
    return api


@pytest.fixture(scope="session")
def fixture_api_sa_with_download_dir(tmpdir_factory):
    output_dir = tmpdir_factory.mktemp("hdsr_fewspy_test_dir")  # tmpdir_factory can do session scope. nice!
    output_dir_path = Path(output_dir)
    assert output_dir_path.is_dir()
    api = Api(pi_settings=pi_settings_sa, output_directory_root=output_dir_path)
    assert api.pi_settings.base_url == pi_settings_sa.base_url
    assert api.pi_settings.ssl_verify == True  # noqa
    assert api.pi_settings.settings_name == "default stand-alone"
    assert api.pi_settings.filter_id == "INTERNAL-API"
    assert api.pi_settings.service == "FewsWebServices"
    assert api.pi_settings.module_instance_ids == "WerkFilter"
    return api
